/*
This file is part of the Juju GUI, which lets users view and manage Juju
environments within a graphical interface (https://launchpad.net/juju-gui).
Copyright (C) 2017 Canonical Ltd.

This program is free software: you can redistribute it and/or modify it under
the terms of the GNU Affero General Public License version 3, as published by
the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranties of MERCHANTABILITY,
SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero
General Public License for more details.

You should have received a copy of the GNU Affero General Public License along
with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

'use strict';

YUI.add('account-payment-method-card', function () {

  juju.components.AccountPaymentMethodCard = React.createClass({
    displayName: 'AccountPaymentMethodCard',

    propTypes: {
      card: React.PropTypes.object.isRequired
    },

    getInitialState: function () {
      return {
        cardFlipped: false
      };
    },

    /**
      Handle toggling the card state.
       @method _handleCardClick
      @param {Object} e The click event from the checkbox.
    */
    _handleCardClick: function (e) {
      e.stopPropagation();
      this.setState({ cardFlipped: !this.state.cardFlipped });
    },

    render: function () {
      const card = this.props.card;
      const cardClasses = classNames('account__payment-card-wrapper', { 'account__payment-card-wrapper--flipped': this.state.cardFlipped });
      const address = card.address;
      return React.createElement(
        'div',
        { className: 'account__payment-card' },
        React.createElement(
          'div',
          { className: cardClasses,
            onClick: this._handleCardClick },
          React.createElement(
            'div',
            { className: 'account__payment-card-container' },
            React.createElement(
              'div',
              { className: 'account__payment-card-front' },
              React.createElement('div', { className: 'account__payment-card-overlay' }),
              React.createElement(
                'div',
                { className: 'account__payment-card-name' },
                card.name
              )
            ),
            React.createElement(
              'div',
              { className: 'account__payment-card-back' },
              React.createElement('div', { className: 'account__payment-card-overlay' }),
              React.createElement(
                'div',
                { className: 'account__payment-card-number' },
                'xxxx xxxx xxxx ',
                card.last4
              ),
              React.createElement(
                'div',
                { className: 'account__payment-card-bottom' },
                React.createElement(
                  'div',
                  { className: 'account__payment-card-expiry' },
                  card.month,
                  '/',
                  card.year
                ),
                React.createElement(
                  'div',
                  { className: 'account__payment-card-brand' },
                  card.brand
                )
              )
            )
          )
        ),
        React.createElement(
          'div',
          { className: 'account__payment-card-info' },
          React.createElement(
            'h4',
            null,
            'Card address'
          ),
          React.createElement(
            'p',
            null,
            address.line1
          ),
          React.createElement(
            'p',
            null,
            address.line2
          ),
          React.createElement(
            'p',
            null,
            address.city,
            ' ',
            address.state
          ),
          React.createElement(
            'p',
            null,
            address.country,
            ' ',
            address.postcode
          )
        )
      );
    }

  });
}, '', {
  requires: []
});